////////////////////////////////////////////////////////////////////////////////
// gҏWpg[J[utB^
// -----------------------------------------------------------------------------
// ɓ삳ɂ
// lua51.dll xǂݍ݂Kv܂B
////////////////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <windows.h>

#include <filter.h>

#include <lua.hpp>

#pragma comment(lib, "lua51.lib")

#include "aulslib.h"

////////////////////////////////////////////////////////////////////////////////
// 萔
////////////////////////////////////////////////////////////////////////////////

static const LPSTR FILTER_NAME = "g[J[u";

static const LPCSTR TCWND_CLASSNAME = "Auls ToneCurve";
static const int TCWND_ID = 12345;

static const DWORD TONECURVE_MAX = 50+1;
static const DWORD TONECURVE_SIZE = 256;
static const DWORD TONECURVE_SAVEDATASIZE = (TONECURVE_MAX-1) * TONECURVE_SIZE * sizeof(BYTE);

static const DWORD TONECURVE_COLOR_ENABLED  = 0x000000;
static const DWORD TONECURVE_COLOR_DISABLED = 0xC0C0C0;

static const LPCSTR TCDATAFILE_FILTER = "g[J[uf[^(*.tcdata)\0*.tcdata\0ׂẴt@C(*.*)\0*.*\0";

////////////////////////////////////////////////////////////////////////////////
// O[oϐ
////////////////////////////////////////////////////////////////////////////////

auls::CWindow g_TcWnd; // g[J[uEBhE
auls::CPen g_TcPenEnabled;
auls::CPen g_TcPenDisabled;

DWORD g_tcindex = 0;
BYTE g_tcdata[TONECURVE_MAX][TONECURVE_SIZE] = {};

POINT g_PrevPt = {};

bool g_rbuttondrag = false;
POINT g_RButtonPt = {};

////////////////////////////////////////////////////////////////////////////////
// ėp֐
////////////////////////////////////////////////////////////////////////////////

// LPARAM  POINT ^ɕϊ
void LParamToPoint(POINT *p, LPARAM lp)
{
	p->x = (short)LOWORD(lp);
	p->y = (short)HIWORD(lp);
}

// F]`
void DrawNotLine(HDC hdc, int x1, int y1, int x2, int y2)
{
	SetROP2(hdc, R2_NOT);
	MoveToEx(hdc, x1, y1, NULL);
	LineTo(hdc, x2, y2);
}

// fobObZ[W
void Dbg(LPCSTR fmt, ...)
{
	char buf[256];
	va_list args;
	va_start(args, fmt);
	vsnprintf_s(buf, sizeof(buf), _TRUNCATE, fmt, args);
	va_end(args);
	OutputDebugString(buf);
}

////////////////////////////////////////////////////////////////////////////////
// g[J[uf[^
////////////////////////////////////////////////////////////////////////////////

// g[J[u̓_ݒ
void SetTcPoint(DWORD index, int x, int y)
{
	if(x < 0 || x > 255) return;
	if(y < 0) y = 0;
	else if(y > 255) y = 255;
	g_tcdata[index][x] = 255 - y;
}

// g[J[u̓_ݒ(͈)
void SetTcPoint(DWORD index, int x1, int y1, int x2, int y2)
{
	if(x1 > x2) { auls::Swap(x1, x2); auls::Swap(y1, y2); }
	int x_diff = x2 - x1, y_diff = y2 - y1;
	for(int i = 0; i < x_diff; i++) {
		SetTcPoint(index, x1 + i, y1 + y_diff * i / x_diff);
	}
	SetTcPoint(index, x2, y2);
}

// g[J[uE]
void ReverseTcDataH(DWORD index)
{
	if(index >= TONECURVE_MAX) return;
	BYTE temp[TONECURVE_SIZE];
	memcpy(temp, g_tcdata[index], TONECURVE_SIZE);
	for(DWORD i = 0; i < TONECURVE_SIZE; i++) g_tcdata[index][i] = temp[TONECURVE_SIZE-i-1];
}

// g[J[u㉺]
void ReverseTcDataV(DWORD index)
{
	if(index >= TONECURVE_MAX) return;
	for(DWORD i = 0; i < TONECURVE_SIZE; i++) g_tcdata[index][i] = ~g_tcdata[index][i];
}

// g[J[uf[^
void InitTcData(DWORD index)
{
	if(index >= TONECURVE_MAX) return;
	for(DWORD i = 0; i < TONECURVE_SIZE; i++) g_tcdata[index][i] = (BYTE)i;
}

// SẴg[J[uf[^
void InitAllTcData(void)
{
	for(DWORD i = 0; i < TONECURVE_MAX; i++) InitTcData(i);
}

// g[J[uf[^ǂݍ
bool LoadTcData(DWORD index, HWND owner)
{
	if(index == 0 || index >= TONECURVE_MAX) return false;
	auls::CFixedPath Path;
	if(!Path.OpenFileDialog(owner, TCDATAFILE_FILTER, NULL, "g[J[uf[^ǂݍ")) return false;
	auls::CFile File;
	if(!File.OpenExisting(Path)) return false;
	return File.Read(g_tcdata[index], TONECURVE_SIZE) == TRUE;
}

// g[J[uf[^ۑ
bool SaveTcData(DWORD index, HWND owner)
{
	if(index == 0 || index >= TONECURVE_MAX) return false;
	auls::CFixedPath Path;
	if(!Path.SaveFileDialog(owner, TCDATAFILE_FILTER, NULL, "g[J[uf[^ۑ")) return false;
	auls::CFile File;
	if(!File.CreateAlways(Path)) return false;
	return File.Write(g_tcdata[index], TONECURVE_SIZE) == TRUE;
}

////////////////////////////////////////////////////////////////////////////////
// g[J[uEBhE
////////////////////////////////////////////////////////////////////////////////

// g[J[u`
void DrawTc(HDC hdc, DWORD index, HPEN pen)
{
	SelectObject(hdc, pen);
	for(DWORD i = 0; i < TONECURVE_SIZE; i++) {
		MoveToEx(hdc, i, 255, NULL);
		LineTo(hdc, i, 255 - g_tcdata[index][i] - 1);
	}
}

// EBhEvV[W
LRESULT CALLBACK TcWndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp)
{
	switch(msg) {
		case WM_LBUTTONDOWN:
			if(g_rbuttondrag) {
				ReleaseCapture();
				HDC hdc = GetDC(hwnd);
				DrawNotLine(hdc, g_PrevPt.x, g_PrevPt.y, g_RButtonPt.x, g_RButtonPt.y);
				ReleaseDC(hwnd, hdc);
				g_rbuttondrag = false;
			} else {
				LParamToPoint(&g_PrevPt, lp);
				SetTcPoint(g_tcindex, g_PrevPt.x, g_PrevPt.y);
				RECT r = { g_PrevPt.x, 0, g_PrevPt.x+1, 255 };
				InvalidateRect(hwnd, &r, TRUE);
				SetCapture(hwnd);
				SendMessage(GetParent(hwnd), WM_COMMAND, (WPARAM)TCWND_ID, 0);
				g_rbuttondrag = false;
			}
			return 0;
		case WM_NCLBUTTONDOWN: // ㉺E[ł₷悤ɔNCAg̈̃}EX󂯕t
			if(g_rbuttondrag) {
				ReleaseCapture();
				HDC hdc = GetDC(hwnd);
				DrawNotLine(hdc, g_PrevPt.x, g_PrevPt.y, g_RButtonPt.x, g_RButtonPt.y);
				ReleaseDC(hwnd, hdc);
				g_rbuttondrag = false;
			} else {
				LParamToPoint(&g_PrevPt, lp);
				ScreenToClient(hwnd, &g_PrevPt);
				g_rbuttondrag = false;
				SetCapture(hwnd);
			}
			return 0;
		case WM_LBUTTONUP:
			ReleaseCapture();
			return 0;
		case WM_RBUTTONDOWN:
			{
				SetCapture(hwnd);
				LParamToPoint(&g_PrevPt, lp);
				g_RButtonPt = g_PrevPt;
				g_rbuttondrag = true;
				HDC hdc = GetDC(hwnd);
				DrawNotLine(hdc, (short)LOWORD(lp), (short)HIWORD(lp), g_RButtonPt.x, g_RButtonPt.y);
				ReleaseDC(hwnd, hdc);
			}
			return 0;
		case WM_NCRBUTTONDOWN: // ㉺E[ł₷悤ɔNCAg̈̃}EX󂯕t
			{
				SetCapture(hwnd);
				LParamToPoint(&g_PrevPt, lp);
				ScreenToClient(hwnd, &g_PrevPt);
				g_RButtonPt = g_PrevPt;
				g_rbuttondrag = true;
			}
			return 0;
		case WM_RBUTTONUP:
			if(g_rbuttondrag) {
				ReleaseCapture();
				HDC hdc = GetDC(hwnd);
				DrawNotLine(hdc, g_PrevPt.x, g_PrevPt.y, g_RButtonPt.x, g_RButtonPt.y);
				ReleaseDC(hwnd, hdc);
				long x = (short)LOWORD(lp), y = (short)HIWORD(lp);
				SetTcPoint(g_tcindex, x, y, g_RButtonPt.x, g_RButtonPt.y);
				g_rbuttondrag = false;
				RECT r = { auls::Min(x, g_RButtonPt.x), 0, auls::Max(x, g_RButtonPt.x)+1, 255 };
				InvalidateRect(hwnd, &r, TRUE);
				UpdateWindow(hwnd);
				SendMessage(GetParent(hwnd), WM_COMMAND, (WPARAM)TCWND_ID, 0);
			}
			return 0;
		case WM_MOUSEMOVE:
			if(GetCapture() == hwnd) {
				if(g_rbuttondrag) {
					HDC hdc = GetDC(hwnd);
					DrawNotLine(hdc, g_PrevPt.x, g_PrevPt.y, g_RButtonPt.x, g_RButtonPt.y);
					DrawNotLine(hdc, (short)LOWORD(lp), (short)HIWORD(lp), g_RButtonPt.x, g_RButtonPt.y);
					ReleaseDC(hwnd, hdc);
				} else {
					long x = (short)LOWORD(lp), y = (short)HIWORD(lp);
					SetTcPoint(g_tcindex, x, y, g_PrevPt.x, g_PrevPt.y);
					RECT r = { auls::Min(x, g_PrevPt.x), 0, auls::Max(x, g_PrevPt.x)+1, 255 };
					InvalidateRect(hwnd, &r, TRUE);
					UpdateWindow(hwnd);
					SendMessage(GetParent(hwnd), WM_COMMAND, (WPARAM)TCWND_ID, 0);
				}
				LParamToPoint(&g_PrevPt, lp);
			}
			return 0;
		case WM_PAINT:
			{
				PAINTSTRUCT ps;
				BeginPaint(hwnd, &ps);
				DrawTc(ps.hdc, g_tcindex, IsWindowEnabled(hwnd) ? g_TcPenEnabled : g_TcPenDisabled);
				EndPaint(hwnd, &ps);
			}
			return 0;
		default:
			return DefWindowProc(hwnd, msg, wp, lp);
	}
}

// g[J[uEBhE쐬
bool CreateTcWindow(FILTER *fp)
{
	// EBhENXo^
	WNDCLASSEX wc;
	wc.cbSize        = sizeof(wc);
	wc.style         = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc   = TcWndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = fp->dll_hinst;
	wc.hIcon         = (HICON)LoadImage(NULL, IDI_APPLICATION, IMAGE_ICON, 0, 0, LR_SHARED | LR_DEFAULTSIZE);
	wc.hCursor       = (HCURSOR)LoadImage(NULL, IDC_ARROW, IMAGE_CURSOR, 0, 0, LR_SHARED | LR_DEFAULTSIZE);
	wc.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName  = NULL;
	wc.lpszClassName = TCWND_CLASSNAME;
	wc.hIconSm       = NULL;
	if(!RegisterClassEx(&wc)) return false;

	{
		RECT cr;
		GetClientRect(fp->hwnd, &cr);
		int width = 256+(GetSystemMetrics(SM_CXEDGE)+GetSystemMetrics(SM_CXBORDER))*2;
		int x = (cr.right - width) / 2;
		g_TcWnd.Create(TCWND_CLASSNAME, NULL, WS_CHILD | WS_VISIBLE | WS_DISABLED | WS_BORDER, WS_EX_CLIENTEDGE,
			x, cr.bottom - 265, width, 256+(GetSystemMetrics(SM_CYEDGE)+GetSystemMetrics(SM_CXBORDER))*2-1,
			fp->hwnd, (HMENU)TCWND_ID, fp->dll_hinst, NULL);
		if(!g_TcWnd) return false;
	}

	return true;
}

////////////////////////////////////////////////////////////////////////////////
// tB^֐
////////////////////////////////////////////////////////////////////////////////

// 
BOOL func_init(FILTER *fp)
{
	if(!CreateTcWindow(fp)) return FALSE;
	if(!g_TcPenEnabled.Create(TONECURVE_COLOR_ENABLED)) return FALSE;
	if(!g_TcPenDisabled.Create(TONECURVE_COLOR_DISABLED)) return FALSE;
	InitAllTcData();
	return TRUE;
}

// I
BOOL func_exit(FILTER *fp)
{
	// ݒEBhEjODLLA[ĥ
	// DLLŒ`vV[WEBhE
	// IɔjĂKv
	g_TcWnd.Destroy();
	return TRUE;
}

// XV̏
BOOL func_update(FILTER *fp, int status)
{
	if(status == FILTER_UPDATE_STATUS_TRACK+0 || status == FILTER_UPDATE_STATUS_ALL) {
		g_tcindex = fp->track[0];
		g_TcWnd.Redraw(TRUE);
	}
	return TRUE;
}

// {^̏
BOOL ButtonCommand(FILTER *fp, void *editp, int btn)
{
	if(!fp->exfunc->is_editing(editp)) return FALSE;

	switch(btn) {
		case 0:
			ReverseTcDataH(fp->track[0]);
			g_TcWnd.Redraw(TRUE);
			return TRUE;
		case 1:
			ReverseTcDataV(fp->track[0]);
			g_TcWnd.Redraw(TRUE);
			return TRUE;
		case 2:
			InitTcData(fp->track[0]);
			g_TcWnd.Redraw(TRUE);
			return TRUE;
		case 3:
			if(LoadTcData(g_tcindex, fp->hwnd)) {
				g_TcWnd.Redraw(TRUE);
				return  TRUE;
			} else {
				return FALSE;
			}
		case 4:
			SaveTcData(g_tcindex, fp->hwnd);
			return FALSE;
		default:
			return FALSE;
	}
}

// EBhEbZ[W̏
BOOL func_WndProc(HWND hwnd, UINT msg, WPARAM wp, LPARAM lp, void *editp, FILTER *fp)
{
	switch(msg) {
		case WM_COMMAND:
			switch(LOWORD(wp)) {
				case MID_FILTER_BUTTON+0:
				case MID_FILTER_BUTTON+1:
				case MID_FILTER_BUTTON+2:
				case MID_FILTER_BUTTON+3:
				case MID_FILTER_BUTTON+4:
					return ButtonCommand(fp, editp, LOWORD(wp)-MID_FILTER_BUTTON);
				case TCWND_ID:
					return TRUE;
			}
			break;
		case WM_KEYDOWN: // ̃EBhEANeBuȎłAV[gJbgL[ł悤ɂ
		case WM_SYSKEYDOWN:
			SendMessage(GetWindow(fp->hwnd, GW_OWNER), msg, wp, lp);
			break;
		case WM_FILTER_CHANGE_EDIT:
			g_TcWnd.Enable(fp->exfunc->is_editing(editp));
			InitAllTcData();
			g_TcWnd.Redraw(TRUE);
			break;
	}

	return FALSE;
}

// vWFNg[h̏
BOOL func_project_load(FILTER *fp, void *editp, void *data, int size)
{
	memcpy(g_tcdata[1], data, auls::Min<const DWORD>(size, TONECURVE_SAVEDATASIZE));
	return TRUE;
}

// vWFNgZ[ȕ
BOOL func_project_save(FILTER *fp, void *editp, void *data, int *size)
{
	if(!data) {
		*size = TONECURVE_SAVEDATASIZE;
	} else {
		memcpy(data, g_tcdata[1], TONECURVE_SAVEDATASIZE);
	}
	return TRUE;
}

////////////////////////////////////////////////////////////////////////////////
// tB^pGg|Cg
////////////////////////////////////////////////////////////////////////////////

LPSTR track_name[] = { "ԍ" };
int   track_def[]  = { 1 };
int   track_min[]  = { 1 };
int   track_max[]  = { TONECURVE_MAX-1 };

LPSTR check_name[] = { "g[J[uE]", "g[J[u㉺]", "g[J[u", "g[J[uǂݍ", "g[J[uۑ" };
int   check_def[]  = { -1, -1, -1, -1, -1 };

FILTER_DLL filter = {
	FILTER_FLAG_ALWAYS_ACTIVE | FILTER_FLAG_WINDOW_SIZE,
	FILTER_WINDOW_SIZE_ADD | 0, FILTER_WINDOW_SIZE_ADD | 264,
	FILTER_NAME,
	auls::ElemOf(track_name), track_name, track_def, track_min, track_max,
	auls::ElemOf(check_name), check_name, check_def,
	NULL,
	func_init,
	func_exit,
	func_update,
	func_WndProc,
	NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL,
	func_project_load,
	func_project_save,
};

extern "C" __declspec(dllexport) FILTER_DLL *GetFilterTable(void)
{
	return &filter;
}

////////////////////////////////////////////////////////////////////////////////
// Lua֐
////////////////////////////////////////////////////////////////////////////////

// g[J[u擾
int l_gettc(lua_State *L)
{
	switch(lua_gettop(L)) {
		case 0:
			lua_pushlightuserdata(L, g_tcdata[0]);
			break;
		case 1: // g[J[uf[^̂܂ܕԂ
			{
				DWORD i = (DWORD)luaL_checknumber(L, 1);
				if(i >= TONECURVE_MAX) i = 0;
				lua_pushlightuserdata(L, g_tcdata[i]);
			}
			break;
		case 2: // g[J[uf[^zVtg
			{
				DWORD i = (DWORD)luaL_checknumber(L, 1);
				if(i >= TONECURVE_MAX) i = 0;
				BYTE rotate = lua_tointeger(L, 2);
				BYTE*p = (BYTE*)lua_newuserdata(L, 256);
				memcpy(p, g_tcdata[i]+rotate, 256 - rotate);
				memcpy(p + 256 - rotate, g_tcdata[i], rotate);
			}
			break;
		case 3: // 2̃g[J[uf[^̒Ԃ̒l
		default:
			{
				DWORD index1 = (DWORD)lua_tonumber(L, 1);
				if(index1 >= TONECURVE_MAX) index1 = 0;
				DWORD index2 = (DWORD)lua_tonumber(L, 2);
				if(index2 >= TONECURVE_MAX) index2 = 0;
				BYTE  transi = (BYTE)lua_tonumber(L, 3);
				BYTE*p = (BYTE*)lua_newuserdata(L, 256);
				for(int i = 0; i < 256; i++) p[i] = ((g_tcdata[index1][i] * (255 - transi)) + (g_tcdata[index2][i] * transi)) / 255;
			}
			break;
	}
	return 1;
}

// g[J[uŉ摜u
int l_settc(lua_State *L)
{
	auls::PixelDataArgs px(L, 1);
	BYTE *tc_r = (BYTE*)lua_touserdata(L, 4); if(!tc_r) tc_r = g_tcdata[0];
	BYTE *tc_g = (BYTE*)lua_touserdata(L, 5); if(!tc_g) tc_g = g_tcdata[0];
	BYTE *tc_b = (BYTE*)lua_touserdata(L, 6); if(!tc_b) tc_b = g_tcdata[0];
	BYTE *tc_a = (BYTE*)lua_touserdata(L, 7); if(!tc_a) tc_a = g_tcdata[0];
	lua_settop(L, 1);

	for(DWORD i = px.w * px.h; i;) {
		i--;
		auls::RgbaValue v = px.data[i];
		v.r = tc_r[v.r];
		v.g = tc_g[v.g];
		v.b = tc_b[v.b];
		v.a = tc_a[v.a];
		px.data[i] = v;
	}

	return 1;
}

////////////////////////////////////////////////////////////////////////////////
// LuapGg|Cg
////////////////////////////////////////////////////////////////////////////////

luaL_reg luatable[] = {
	{ "get_tonecurve", l_gettc },
	{ "set_tonecurve", l_settc },
	{ NULL, NULL },
};

extern "C" __declspec(dllexport) int luaopen_auls_tonecurve(lua_State *L)
{
	luaL_register(L, "Auls", luatable);
	return 1;
}
